﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class CameraMovement : MonoBehaviour
{

    public float Speed = 1.5f;
    public float Spacing = .5f;
    private Vector3 Pos;
    public Camera VRCamera;

    GameObject CameraObject;
    PatternRecognition PatternScript;
    Fast_Movement_Pattern FMPScript;




    void Start()
    {
        Pos = transform.position;
        CameraObject = GameObject.Find("VRDisplayTracked");
        PatternScript = CameraObject.GetComponent<PatternRecognition>();
        FMPScript = CameraObject.GetComponent<Fast_Movement_Pattern>();
    }

    void Update()
    {
        if (Input.GetKeyDown(KeyCode.S))
        {
            Vector3 Direction = VRCamera.transform.position + VRCamera.transform.rotation * Vector3.back * 5f;
            Direction.y = 0.0f;
            transform.position = Direction;
        }
        if (Input.GetKeyDown(KeyCode.W))
        {
            Vector3 Direction = VRCamera.transform.position + VRCamera.transform.rotation * Vector3.forward * 5f;
            Direction.y = 0.0f;
            transform.position = Direction;
        }
        if (Input.GetKeyDown(KeyCode.D))
        {
            Pos.x -= Spacing;
            transform.Rotate(0f, VRCamera.transform.rotation.y + 90f, 0f);// CameraFacing.transform.rotation
        }
        if (Input.GetKeyDown(KeyCode.A))
        {
            Pos.x += Spacing;
            transform.Rotate(0f, VRCamera.transform.rotation.y - 90f, 0f);
        }
        if (Input.GetKeyDown(KeyCode.R))
        {
            transform.position = new Vector3(1, 1, 1);
        }
        //transform.position = Vector3.MoveTowards(transform.position, pos, speed * Time.deltaTime);

        if (Input.GetKeyDown(KeyCode.Space))
        {
            PatternScript.OpenMenu();
        }

    }
}
