﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Cursor : MonoBehaviour {
    public Camera VRCamera;
    private Vector3 OriginalScale;
    public float Distance;


	// Use this for initialization
	void Start () {
        OriginalScale = transform.localScale;

    }
	
	// Update is called once per frame
	void Update () {        
        RaycastHit hit;        
        if (Physics.Raycast (new Ray(VRCamera.transform.position,
                                     VRCamera.transform.rotation * Vector3.forward),
                             out hit)) {  //if camera has object in front of itself, the distance will be set as distance towards the object raycast hits
            if (hit.transform.tag != "Button") Distance = hit.distance;
        } else {
            Distance = VRCamera.farClipPlane * 0.95f; //if
        }
        transform.position = VRCamera.transform.position + VRCamera.transform.rotation * Vector3.forward * Distance; //Quad will be placed in "distance" length in front of camera
        transform.LookAt(VRCamera.transform.position); //Quad will always face towards camera
        transform.Rotate(0.0f, 180.0f, 0.0f); // Quad is facing camera with its front side
        if (Distance < 10.0f) {
            Distance *= 1 + 4 * Mathf.Pow(4, -Distance); // when object is close, it will make reticle to have bigger screen size
            //distance *= 1 + 2 * Mathf.Exp(-distance);
        }
        transform.localScale = OriginalScale * Distance;        
    }
}
