﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class SelectionManager : MonoBehaviour
{
    [SerializeField]
    private Camera VRCamera;

    [SerializeField]
    private string SelectableTag = "Selectable";

    public bool[] WhichNumber;

    [SerializeField]
    private Material SelectedMaterial;
    [SerializeField]
    private Material DeselectedMaterial;

    public GameObject SelectedObject;

    private Transform SelectionTransform;

    public bool Highlightning = false;

    public TextMesh ObjectNameText;
    public Vector3 PlaceOfHit;

    GameObject CameraObject;
    PatternRecognition PatternScript;

    GameObject ColorChangerObj;
    ColorChanger ColorChangerScript;

    bool EnteredMenu = false;

    public AudioClip MusicClip1;
    public AudioClip MusicClip2;
    public AudioClip MusicClip3;
    public AudioClip MusicClip4;

    public AudioSource MusicSource;

    public Material GreenMaterial;
    public Material YellowMaterial;
    public Material BlueMaterial;
    public Material PurpleMaterial;

    ColorChanger GO;
    GameObject SelectedObj;
    Fast_Movement_Pattern FMPscript;

    public RaycastHit hit;



    private void Start()
    {
        CameraObject = GameObject.Find("VRDisplayTracked");
        PatternScript = CameraObject.GetComponent<PatternRecognition>();
        FMPscript = CameraObject.GetComponent<Fast_Movement_Pattern>();

        ColorChangerObj = GameObject.Find("Cube1");
        ColorChangerScript = ColorChangerObj.transform.GetComponent<ColorChanger>();
        WhichNumber = new bool[8];
        WhichNumber[0] = true;
        WhichNumber[1] = false;
        WhichNumber[2] = true;
        WhichNumber[3] = false;
        WhichNumber[4] = true;
        WhichNumber[5] = false;
        WhichNumber[6] = true;
        WhichNumber[7] = false;
    }

    private void Update()
    {
        if (Highlightning == true)
        {
            DehighlightObjects();
        }
        var ray = VRCamera.ViewportPointToRay(new Vector3(0.5f, 0.5f, 0f));

        
        if (Physics.Raycast(ray, out hit))
        {
            if (!PatternScript.IsLocked)
            {
                GO = hit.collider.GetComponent<ColorChanger>();
            }
            PlaceOfHit = hit.point;
            SelectedObject = hit.collider.gameObject;
            if (hit.collider.name == "Button4")
            {
                PatternScript.CloseMenu();
                //button.gameObject.SetActive(false);
            }
            else if (hit.collider.name == "Button0")
            {
                if (GO != null)
                {
                    GO.ChangeMaterial(hit.collider.GetComponent<Renderer>(), 4);
                }
                PatternScript.CloseMenu();
            }
            else if (hit.collider.name == "Button6")
            {
                GameObject.Find("VRDisplayTracked").transform.Rotate(0.0f, -90.0f, 0.0f);
                PatternScript.CloseMenu();
            }
            else if (hit.collider.name == "Button2")
            {
                GameObject.Find("VRDisplayTracked").transform.Rotate(0.0f, 90.0f, 0.0f);
                PatternScript.CloseMenu();
            }
            else if (hit.collider.name == "Button1")
            {
                if (GO != null)
                {
                    GO.ChangeMaterial(hit.collider.GetComponent<Renderer>(), 0);
                    //FMPscript.LockedObj.GetComponent<ColorChanger>().ChangeMaterial(hit.collider.GetComponent<Renderer>(), 0);
                }
                MusicSource.clip = MusicClip1;
                MusicSource.Play();
                PatternScript.CloseMenu();
            }
            else if (hit.collider.name == "Button3")
            {
                if (GO != null)
                {
                    GO.ChangeMaterial(hit.collider.GetComponent<Renderer>(), 1);
                }
                MusicSource.clip = MusicClip2;
                MusicSource.Play();
                PatternScript.CloseMenu();
            }
            else if (hit.collider.name == "Button5")
            {
                if (GO != null)
                {
                    GO.ChangeMaterial(hit.collider.GetComponent<Renderer>(), 2);
                }
                MusicSource.clip = MusicClip3;
                MusicSource.Play();
                PatternScript.CloseMenu();
            }
            else if (hit.collider.name == "Button7")
            {
                if (GO != null)
                {
                    GO.ChangeMaterial(hit.collider.GetComponent<Renderer>(), 3);
                }
                MusicSource.clip = MusicClip4;
                MusicSource.Play();
                PatternScript.CloseMenu();
            }


            var selection = hit.transform;
            if (selection.CompareTag(SelectableTag) && !PatternScript.IsLocked)
            {
                SelectedObject = hit.transform.gameObject;
                ObjectNameText.text = hit.transform.gameObject.name;

                if (Highlightning == true)
                {
                    HighlightObjects(hit, selection);
                }

            }
            else
            {
                if (!PatternScript.IsLocked)
                {
                    ObjectNameText.text = "";
                }
                return;
            }
        }
    }

    void HighlightObjects(RaycastHit hit, Transform selection)
    {
        
        var selectionRender = selection.GetComponent<Renderer>();
        if (selectionRender != null)
        {
            selectionRender.material = SelectedMaterial;
        }
        SelectionTransform = selection;
    }

    void DehighlightObjects()
    {
        if (SelectionTransform != null && !PatternScript.IsLocked)
        {
            var SelectionRender = SelectionTransform.GetComponent<Renderer>();
            SelectionRender.material = DeselectedMaterial;
            SelectionTransform = null;
        }
    }
}
